clang-tools 3.8.0

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
clang::tidy::ClangTidyOptions Struct Reference

Contains options for clang-tidy. More...

`#include <ClangTidyOptions.h>`

Collaboration diagram for clang::tidy::ClangTidyOptions:
[legend]

## Public Types
typedef std::pair< std::string, std::string > | StringPair
typedef std::map< std::string, std::string > | OptionMap
typedef std::vector< std::string > | ArgList

## Public Member Functions
ClangTidyOptions | mergeWith (const ClangTidyOptions &Other) const
| Creates a new `ClangTidyOptions` instance combined from all fields of this instance overridden by the fields of `Other` that have a value. More...

## Static Public Member Functions
static ClangTidyOptions | getDefaults ()
| These options are used for all settings that haven't been overridden by the `OptionsProvider`. More...

## Public Attributes
llvm::Optional< std::string > | Checks
| Checks filter. More...
llvm::Optional< std::string > | HeaderFilterRegex
| Output warnings from headers matching this filter. More...
llvm::Optional< bool > | SystemHeaders
| Output warnings from system headers matching `HeaderFilterRegex`. More...
llvm::Optional< bool > | AnalyzeTemporaryDtors
| Turns on temporary destructor-based analysis. More...
llvm::Optional< std::string > | User
| Specifies the name or e-mail of the user running clang-tidy. More...
OptionMap | CheckOptions
| Key-value mapping used to store check-specific options. More...
llvm::Optional< ArgList > | ExtraArgs
| Add extra compilation arguments to the end of the list. More...
llvm::Optional< ArgList > | ExtraArgsBefore
| Add extra compilation arguments to the start of the list. More...

## Detailed Description

Contains options for clang-tidy.

These options may be read from configuration files, and may be different for different translation units.

Definition at line 49 of file ClangTidyOptions.h.

## Member Typedef Documentation

typedef std::vector<std::string> clang::tidy::ClangTidyOptions::ArgList

Definition at line 87 of file ClangTidyOptions.h.

typedef std::map<std::string, std::string> clang::tidy::ClangTidyOptions::OptionMap

Definition at line 82 of file ClangTidyOptions.h.

typedef std::pair<std::string, std::string> clang::tidy::ClangTidyOptions::StringPair

Definition at line 81 of file ClangTidyOptions.h.

## Member Function Documentation

ClangTidyOptions clang::tidy::ClangTidyOptions::getDefaults | ( |  | ) |
| static

These options are used for all settings that haven't been overridden by the `OptionsProvider`.

Allow no checks and no headers by default. This method initializes check-specific options by calling `ClangTidyModule::getModuleOptions()` of each registered `ClangTidyModule`.

Definition at line 103 of file ClangTidyOptions.cpp.

References AnalyzeTemporaryDtors, Checks, HeaderFilterRegex, mergeWith(), SystemHeaders, and User.

Referenced by clang::tidy::ClangTidyContext::getOptionsForFile().

ClangTidyOptions clang::tidy::ClangTidyOptions::mergeWith | ( | const ClangTidyOptions & | Other | ) | const

Creates a new `ClangTidyOptions` instance combined from all fields of this instance overridden by the fields of `Other` that have a value.

Definition at line 118 of file ClangTidyOptions.cpp.

References AnalyzeTemporaryDtors, CheckOptions, Checks, ExtraArgs, ExtraArgsBefore, HeaderFilterRegex, Result, SystemHeaders, and User.

Referenced by clang::tidy::FileOptionsProvider::FileOptionsProvider(), getDefaults(), clang::tidy::ClangTidyContext::getOptionsForFile(), and clang::tidy::FileOptionsProvider::TryReadConfigFile().

## Member Data Documentation

llvm::Optional<bool> clang::tidy::ClangTidyOptions::AnalyzeTemporaryDtors

Turns on temporary destructor-based analysis.

Definition at line 73 of file ClangTidyOptions.h.

Referenced by clang::tidy::ClangTidyASTConsumerFactory::CreateASTConsumer(), clang::tidy::createOptionsProvider(), getDefaults(), llvm::yaml::MappingTraits< ClangTidyOptions >::mapping(), and mergeWith().

OptionMap clang::tidy::ClangTidyOptions::CheckOptions

Key-value mapping used to store check-specific options.

Definition at line 85 of file ClangTidyOptions.h.

Referenced by clang::tidy::clangTidyMain(), clang::tidy::modernize::ModernizeModule::getModuleOptions(), clang::tidy::google::GoogleModule::getModuleOptions(), llvm::yaml::MappingTraits< ClangTidyOptions >::mapping(), mergeWith(), and clang::tidy::setStaticAnalyzerCheckerOpts().

llvm::Optional<std::string> clang::tidy::ClangTidyOptions::Checks

Checks filter.

Definition at line 63 of file ClangTidyOptions.h.

Referenced by clang::tidy::createOptionsProvider(), getDefaults(), llvm::yaml::MappingTraits< ClangTidyOptions >::mapping(), and mergeWith().

llvm::Optional<ArgList> clang::tidy::ClangTidyOptions::ExtraArgs

Add extra compilation arguments to the end of the list.

Definition at line 90 of file ClangTidyOptions.h.

Referenced by llvm::yaml::MappingTraits< ClangTidyOptions >::mapping(), mergeWith(), and clang::tidy::runClangTidy().

llvm::Optional<ArgList> clang::tidy::ClangTidyOptions::ExtraArgsBefore

Add extra compilation arguments to the start of the list.

Definition at line 93 of file ClangTidyOptions.h.

Referenced by llvm::yaml::MappingTraits< ClangTidyOptions >::mapping(), mergeWith(), and clang::tidy::runClangTidy().

llvm::Optional<std::string> clang::tidy::ClangTidyOptions::HeaderFilterRegex

Output warnings from headers matching this filter.

Warnings from main files will always be displayed.

Definition at line 67 of file ClangTidyOptions.h.

Referenced by clang::tidy::createOptionsProvider(), getDefaults(), llvm::yaml::MappingTraits< ClangTidyOptions >::mapping(), and mergeWith().

llvm::Optional<bool> clang::tidy::ClangTidyOptions::SystemHeaders

Output warnings from system headers matching `HeaderFilterRegex`.

Definition at line 70 of file ClangTidyOptions.h.

Referenced by clang::tidy::createOptionsProvider(), getDefaults(), and mergeWith().

llvm::Optional<std::string> clang::tidy::ClangTidyOptions::User

Specifies the name or e-mail of the user running clang-tidy.

This option is used, for example, to place the correct user name in TODO() comments in the relevant check.

Definition at line 79 of file ClangTidyOptions.h.

Referenced by clang::tidy::createOptionsProvider(), getDefaults(), llvm::yaml::MappingTraits< ClangTidyOptions >::mapping(), and mergeWith().

The documentation for this struct was generated from the following files:

- ClangTidyOptions.h
- ClangTidyOptions.cpp